
<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.19: https://docutils.sourceforge.io/" />

    <title>Changelog &#8212; pyfuse3 3.4.0 documentation</title>
    <link rel="stylesheet" type="text/css" href="_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="_static/classic.css" />
    
    <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/_sphinx_javascript_frameworks_compat.js"></script>
    <script src="_static/doctools.js"></script>
    <script src="_static/sphinx_highlight.js"></script>
    
    <link rel="author" title="About these documents" href="about.html" />
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="prev" title="Example File Systems" href="example.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="example.html" title="Example File Systems"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyfuse3 3.4.0 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Changelog</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="changelog">
<h1>Changelog<a class="headerlink" href="#changelog" title="Permalink to this heading">¶</a></h1>
<section id="release-3-4-0-2024-08-28">
<h2>Release 3.4.0 (2024-08-28)<a class="headerlink" href="#release-3-4-0-2024-08-28" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Cythonized with latest Cython 3.0.11 to support Python 3.13.</p></li>
<li><p>CI: also test python 3.13, run mypy.</p></li>
<li><p>Move <code class="docutils literal notranslate"><span class="pre">_pyfuse3</span></code> to <code class="docutils literal notranslate"><span class="pre">pyfuse3._pyfuse3</span></code> and add a compatibility wrapper
for the old name.</p></li>
<li><p>Move <code class="docutils literal notranslate"><span class="pre">pyfuse3_asyncio</span></code> to <code class="docutils literal notranslate"><span class="pre">pyfuse3.asyncio</span></code> and add a compatibility
wrapper for the old name.</p></li>
<li><p>Add <a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#bytes" title="(in Python v3.12)"><code class="xref py py-obj docutils literal notranslate"><span class="pre">bytes</span></code></a> subclass <a class="reference internal" href="data.html#pyfuse3.XAttrNameT" title="pyfuse3.XAttrNameT"><code class="xref py py-obj docutils literal notranslate"><span class="pre">XAttrNameT</span></code></a> as the type of extended attribute names.</p></li>
<li><p>Various fixes to type annotations.</p></li>
<li><p>Add <code class="docutils literal notranslate"><span class="pre">py.typed</span></code> marker to enable external use of type annotations.</p></li>
</ul>
</section>
<section id="release-3-3-0-2023-08-06">
<h2>Release 3.3.0 (2023-08-06)<a class="headerlink" href="#release-3-3-0-2023-08-06" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Note: This is the first pyfuse3 release compatible with Cython 3.0.0 release.
Cython 0.29.x is also still supported.</p></li>
<li><p>Cythonized with latest Cython 3.0.0.</p></li>
<li><p>Drop Python 3.6 and 3.7 support and testing, #71.</p></li>
<li><p>CI: also test python 3.12. test on cython 0.29 and cython 3.0.</p></li>
<li><p>Tell Cython that callbacks may raise exceptions, #80.</p></li>
<li><p>Fix lookup in examples/hello.py, similar to #16.</p></li>
<li><p>Misc. CI, testing, build and sphinx related fixes.</p></li>
</ul>
</section>
<section id="release-3-2-3-2023-05-09">
<h2>Release 3.2.3 (2023-05-09)<a class="headerlink" href="#release-3-2-3-2023-05-09" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>cythonize with latest Cython 0.29.34 (brings Python 3.12 support)</p></li>
<li><p>add a minimal pyproject.toml, require setuptools</p></li>
<li><p>tests: fix integer overflow on 32-bit arches, fixes #47</p></li>
<li><p>test: Use shutil.which() instead of external which(1) program</p></li>
<li><p>setup.py: catch more generic OSError when searching Cython, fixes #63</p></li>
<li><p>setup.py: require Cython &gt;= 0.29</p></li>
<li><p>fix basedir computation in setup.py (fix pip install -e .)</p></li>
<li><p>use sphinx &lt; 6.0 due to compatibility issues with more recent versions</p></li>
</ul>
</section>
<section id="release-3-2-2-2022-09-28">
<h2>Release 3.2.2 (2022-09-28)<a class="headerlink" href="#release-3-2-2-2022-09-28" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>remove support for python 3.5 (broken, out of support by python devs)</p></li>
<li><p>cythonize with latest Cython 0.29.x (brings Python 3.11 support)</p></li>
<li><p>use github actions for CI, remove travis-ci</p></li>
<li><p>update README: minimal maintenance, not developed</p></li>
<li><p>update setup.py with tested python versions</p></li>
<li><p>examples/tmpfs.py: work around strange kernel behaviour (calling SETATTR after
UNLINK of a (not open) file): respond with ENOENT instead of crashing.</p></li>
</ul>
</section>
<section id="release-3-2-1-2021-09-17">
<h2>Release 3.2.1 (2021-09-17)<a class="headerlink" href="#release-3-2-1-2021-09-17" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Add type annotations</p></li>
<li><p>Passing a XATTR_CREATE or XATTR_REPLACE to <a class="reference internal" href="util.html#pyfuse3.setxattr" title="pyfuse3.setxattr"><code class="xref py py-obj docutils literal notranslate"><span class="pre">setxattr</span></code></a> is now working
correctly.</p></li>
</ul>
</section>
<section id="release-3-2-0-2020-12-30">
<h2>Release 3.2.0 (2020-12-30)<a class="headerlink" href="#release-3-2-0-2020-12-30" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Fix long-standing rounding error in file date handling when the nanosecond
part of file dates were &gt; 999999500.</p></li>
<li><p>There is a new <a class="reference internal" href="fuse_api.html#pyfuse3.terminate" title="pyfuse3.terminate"><code class="xref py py-obj docutils literal notranslate"><span class="pre">pyfuse3.terminate()</span></code></a> function to gracefully end the
main loop.</p></li>
</ul>
</section>
<section id="release-3-1-1-2020-10-06">
<h2>Release 3.1.1 (2020-10-06)<a class="headerlink" href="#release-3-1-1-2020-10-06" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>No source changes. Regenerated Cython files with Cython 0.29.21 for Python 3.9
compatibility.</p></li>
</ul>
</section>
<section id="release-3-1-0-2020-05-31">
<h2>Release 3.1.0 (2020-05-31)<a class="headerlink" href="#release-3-1-0-2020-05-31" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Made compatible with newest Trio module.</p></li>
</ul>
</section>
<section id="release-3-0-0-2020-05-08">
<h2>Release 3.0.0 (2020-05-08)<a class="headerlink" href="#release-3-0-0-2020-05-08" title="Permalink to this heading">¶</a></h2>
<ul>
<li><p>Changed <a class="reference internal" href="operations.html#pyfuse3.Operations.create" title="pyfuse3.Operations.create"><code class="xref py py-obj docutils literal notranslate"><span class="pre">create</span></code></a> handler to return a <a class="reference internal" href="data.html#pyfuse3.FileInfo" title="pyfuse3.FileInfo"><code class="xref py py-obj docutils literal notranslate"><span class="pre">FileInfo</span></code></a> struct to allow
for modification of certain kernel file attributes, e.g. <code class="docutils literal notranslate"><span class="pre">direct_io</span></code>.</p>
<p>Note that this change breaks backwards compatibility, code that depends
on the old behavior needs to be changed.</p>
</li>
</ul>
</section>
<section id="release-2-0-0">
<h2>Release 2.0.0<a class="headerlink" href="#release-2-0-0" title="Permalink to this heading">¶</a></h2>
<ul>
<li><p>Changed <a class="reference internal" href="operations.html#pyfuse3.Operations.open" title="pyfuse3.Operations.open"><code class="xref py py-obj docutils literal notranslate"><span class="pre">open</span></code></a> handler to return the new <a class="reference internal" href="data.html#pyfuse3.FileInfo" title="pyfuse3.FileInfo"><code class="xref py py-obj docutils literal notranslate"><span class="pre">FileInfo</span></code></a> struct to
allow for modification of certain kernel file attributes, e.g. <code class="docutils literal notranslate"><span class="pre">direct_io</span></code>.</p>
<p>Note that this change breaks backwards compatibility, code that depends on the old
behavior needs to be changed.</p>
</li>
</ul>
</section>
<section id="release-1-3-1-2019-07-17">
<h2>Release 1.3.1 (2019-07-17)<a class="headerlink" href="#release-1-3-1-2019-07-17" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Fixed a bug in the <code class="file docutils literal notranslate"><span class="pre">hello_asyncio.py</span></code> example.</p></li>
</ul>
</section>
<section id="release-1-3-2019-06-02">
<h2>Release 1.3 (2019-06-02)<a class="headerlink" href="#release-1-3-2019-06-02" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Fixed a bug in the <code class="file docutils literal notranslate"><span class="pre">tmpfs.py</span></code> and <code class="file docutils literal notranslate"><span class="pre">passthroughfs.py</span></code> example
file systems (so rename operations no longer fail).</p></li>
</ul>
</section>
<section id="release-1-2-2018-12-22">
<h2>Release 1.2 (2018-12-22)<a class="headerlink" href="#release-1-2-2018-12-22" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Clarified that <a class="reference internal" href="fuse_api.html#pyfuse3.invalidate_inode" title="pyfuse3.invalidate_inode"><code class="xref py py-obj docutils literal notranslate"><span class="pre">invalidate_inode</span></code></a> may block in some circumstances.</p></li>
<li><p>Added support for using the asyncio module instead of Trio.</p></li>
</ul>
</section>
<section id="release-1-1-2018-11-02">
<h2>Release 1.1 (2018-11-02)<a class="headerlink" href="#release-1-1-2018-11-02" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Fixed <code class="file docutils literal notranslate"><span class="pre">examples/passthroughfs.py</span></code> - was not handling readdir()
correctly.</p></li>
<li><p><a class="reference internal" href="fuse_api.html#pyfuse3.invalidate_entry_async" title="pyfuse3.invalidate_entry_async"><code class="xref py py-obj docutils literal notranslate"><span class="pre">invalidate_entry_async</span></code></a> now accepts an additional <em>ignore_enoent</em>
parameter. When this is set, no errors are logged if the kernel is
not actually aware of the entry that should have been removed.</p></li>
</ul>
</section>
<section id="release-1-0-2018-10-08">
<h2>Release 1.0 (2018-10-08)<a class="headerlink" href="#release-1-0-2018-10-08" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Added a new <a class="reference internal" href="util.html#pyfuse3.syncfs" title="pyfuse3.syncfs"><code class="xref py py-obj docutils literal notranslate"><span class="pre">syncfs</span></code></a> function.</p></li>
</ul>
</section>
<section id="release-0-9-2018-09-27">
<h2>Release 0.9 (2018-09-27)<a class="headerlink" href="#release-0-9-2018-09-27" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>First release</p></li>
<li><p>pyfuse3 was forked from python-llfuse - thanks for all the work!</p></li>
<li><p>If you need compatibility with Python 2.x or libfuse 2.x, you may
want to take a look at python-llfuse instead.</p></li>
</ul>
</section>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper"><h3><a href="index.html">Table Of Contents</a></h3>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="about.html">About</a></li>
<li class="toctree-l1"><a class="reference internal" href="install.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="general.html">General Information</a></li>
<li class="toctree-l1"><a class="reference internal" href="asyncio.html">asyncio Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="fuse_api.html">FUSE API Functions</a></li>
<li class="toctree-l1"><a class="reference internal" href="data.html">Data Structures</a></li>
<li class="toctree-l1"><a class="reference internal" href="operations.html">Request Handlers</a></li>
<li class="toctree-l1"><a class="reference internal" href="util.html">Utility Functions</a></li>
<li class="toctree-l1"><a class="reference internal" href="gotchas.html">Common Gotchas</a></li>
<li class="toctree-l1"><a class="reference internal" href="example.html">Example File Systems</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Changelog</a></li>
</ul>

  <div>
    <h4>Previous topic</h4>
    <p class="topless"><a href="example.html"
                          title="previous chapter">Example File Systems</a></p>
  </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="example.html" title="Example File Systems"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyfuse3 3.4.0 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Changelog</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2024, Nikolaus Rath.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 5.3.0.
    </div>
  </body>
</html>